/*----- PROTECTED REGION ID(PLCsocketClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: PLCsocketClass.cpp,v 1.7 2017-02-23 08:42:46 graziano Exp $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/plcsocket/src/PLCsocketClass.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        PLCsocketClass.cpp
//
// description : C++ source for the PLCsocketClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the PLCsocket once per process.
//
// project :     PLC interlock server
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.7 $
// $Date: 2017-02-23 08:42:46 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <PLCsocket.h>
#include <PLCsocketClass.h>

/*----- PROTECTED REGION END -----*/	//	PLCsocketClass.cpp

//-------------------------------------------------------------------
/**
 *	Create PLCsocketClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_PLCsocket_class(const char *name) {
		return PLCsocket_ns::PLCsocketClass::init(name);
	}
}

namespace PLCsocket_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
PLCsocketClass *PLCsocketClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		PLCsocketClass::PLCsocketClass(string &s)
 * description : 	constructor for the PLCsocketClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
PLCsocketClass::PLCsocketClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering PLCsocketClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(PLCsocketClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::constructor

	cout2 << "Leaving PLCsocketClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		PLCsocketClass::~PLCsocketClass()
 * description : 	destructor for the PLCsocketClass
 */
//--------------------------------------------------------
PLCsocketClass::~PLCsocketClass()
{
	/*----- PROTECTED REGION ID(PLCsocketClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		PLCsocketClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
PLCsocketClass *PLCsocketClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new PLCsocketClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		PLCsocketClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
PLCsocketClass *PLCsocketClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		Beam_dumpClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *Beam_dumpClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "Beam_dumpClass::execute(): arrived" << endl;
	return insert((static_cast<PLCsocket *>(device))->beam_dump());
}

//--------------------------------------------------------
/**
 * method : 		Send_ackClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *Send_ackClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "Send_ackClass::execute(): arrived" << endl;
	return insert((static_cast<PLCsocket *>(device))->send_ack());
}

//--------------------------------------------------------
/**
 * method : 		Seq_state_rstClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *Seq_state_rstClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "Seq_state_rstClass::execute(): arrived" << endl;
	((static_cast<PLCsocket *>(device))->seq_state_rst());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		Test_debugClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *Test_debugClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "Test_debugClass::execute(): arrived" << endl;
	((static_cast<PLCsocket *>(device))->test_debug());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		EnableBPM11_2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *EnableBPM11_2Class::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "EnableBPM11_2Class::execute(): arrived" << endl;
	Tango::DevBoolean argin;
	extract(in_any, argin);
	((static_cast<PLCsocket *>(device))->enable_bpm11_2(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DisableInterlockSCWClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DisableInterlockSCWClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DisableInterlockSCWClass::execute(): arrived" << endl;
	((static_cast<PLCsocket *>(device))->disable_interlock_scw());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DisableInterlockID5Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DisableInterlockID5Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DisableInterlockID5Class::execute(): arrived" << endl;
	((static_cast<PLCsocket *>(device))->disable_interlock_id5());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum PLCsocketClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum PLCsocketClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum PLCsocketClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void PLCsocketClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "Ipaddr";
	prop_desc = "ip address of PLC";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Wport";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Rport";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Srv_host";
	prop_desc = "ip addr of the server";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Hbeat";
	prop_desc = "max time in ms between two read from plc";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Labels";
	prop_desc = "list of labels to be written in the panel";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Logfile";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Db_param";
	prop_desc = "contains the parameter string to access logging db:<BR>\nhostname-user-passwd-db_name-port";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Logging";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Timeadjust";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Ack_policy";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void PLCsocketClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("PLC interlock server");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("PLCsocket");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void PLCsocketClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(PLCsocketClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new PLCsocket(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		PLCsocket *dev = static_cast<PLCsocket *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(PLCsocketClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void PLCsocketClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(PLCsocketClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::attribute_factory_before
	//	Attribute : IThreshold
	IThresholdAttrib	*ithreshold = new IThresholdAttrib();
	Tango::UserDefaultAttrProp	ithreshold_prop;
	//	description	not set for IThreshold
	//	label	not set for IThreshold
	//	unit	not set for IThreshold
	//	standard_unit	not set for IThreshold
	//	display_unit	not set for IThreshold
	//	format	not set for IThreshold
	//	max_value	not set for IThreshold
	//	min_value	not set for IThreshold
	//	max_alarm	not set for IThreshold
	//	min_alarm	not set for IThreshold
	//	max_warning	not set for IThreshold
	//	min_warning	not set for IThreshold
	//	delta_t	not set for IThreshold
	//	delta_val	not set for IThreshold
	
	ithreshold->set_default_properties(ithreshold_prop);
	//	Not Polled
	ithreshold->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(ithreshold);

	//	Attribute : Libera3hc
	Libera3hcAttrib	*libera3hc = new Libera3hcAttrib();
	Tango::UserDefaultAttrProp	libera3hc_prop;
	//	description	not set for Libera3hc
	//	label	not set for Libera3hc
	//	unit	not set for Libera3hc
	//	standard_unit	not set for Libera3hc
	//	display_unit	not set for Libera3hc
	//	format	not set for Libera3hc
	//	max_value	not set for Libera3hc
	//	min_value	not set for Libera3hc
	//	max_alarm	not set for Libera3hc
	//	min_alarm	not set for Libera3hc
	//	max_warning	not set for Libera3hc
	//	min_warning	not set for Libera3hc
	//	delta_t	not set for Libera3hc
	//	delta_val	not set for Libera3hc
	
	libera3hc->set_default_properties(libera3hc_prop);
	//	Not Polled
	libera3hc->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(libera3hc);

	//	Attribute : BeamDumpPLCA10
	BeamDumpPLCA10Attrib	*beamdumpplca10 = new BeamDumpPLCA10Attrib();
	Tango::UserDefaultAttrProp	beamdumpplca10_prop;
	//	description	not set for BeamDumpPLCA10
	//	label	not set for BeamDumpPLCA10
	//	unit	not set for BeamDumpPLCA10
	//	standard_unit	not set for BeamDumpPLCA10
	//	display_unit	not set for BeamDumpPLCA10
	//	format	not set for BeamDumpPLCA10
	//	max_value	not set for BeamDumpPLCA10
	//	min_value	not set for BeamDumpPLCA10
	//	max_alarm	not set for BeamDumpPLCA10
	//	min_alarm	not set for BeamDumpPLCA10
	//	max_warning	not set for BeamDumpPLCA10
	//	min_warning	not set for BeamDumpPLCA10
	//	delta_t	not set for BeamDumpPLCA10
	//	delta_val	not set for BeamDumpPLCA10
	
	beamdumpplca10->set_default_properties(beamdumpplca10_prop);
	//	Not Polled
	beamdumpplca10->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(beamdumpplca10);

	//	Attribute : BeamAbi
	BeamAbiAttrib	*beamabi = new BeamAbiAttrib();
	Tango::UserDefaultAttrProp	beamabi_prop;
	//	description	not set for BeamAbi
	//	label	not set for BeamAbi
	//	unit	not set for BeamAbi
	//	standard_unit	not set for BeamAbi
	//	display_unit	not set for BeamAbi
	//	format	not set for BeamAbi
	//	max_value	not set for BeamAbi
	//	min_value	not set for BeamAbi
	//	max_alarm	not set for BeamAbi
	//	min_alarm	not set for BeamAbi
	//	max_warning	not set for BeamAbi
	//	min_warning	not set for BeamAbi
	//	delta_t	not set for BeamAbi
	//	delta_val	not set for BeamAbi
	
	beamabi->set_default_properties(beamabi_prop);
	//	Not Polled
	beamabi->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(beamabi);

	//	Attribute : CallPm
	CallPmAttrib	*callpm = new CallPmAttrib();
	Tango::UserDefaultAttrProp	callpm_prop;
	//	description	not set for CallPm
	//	label	not set for CallPm
	//	unit	not set for CallPm
	//	standard_unit	not set for CallPm
	//	display_unit	not set for CallPm
	//	format	not set for CallPm
	//	max_value	not set for CallPm
	//	min_value	not set for CallPm
	//	max_alarm	not set for CallPm
	//	min_alarm	not set for CallPm
	//	max_warning	not set for CallPm
	//	min_warning	not set for CallPm
	//	delta_t	not set for CallPm
	//	delta_val	not set for CallPm
	
	callpm->set_default_properties(callpm_prop);
	//	Not Polled
	callpm->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(callpm);

	//	Attribute : AlIThreshold
	AlIThresholdAttrib	*alithreshold = new AlIThresholdAttrib();
	Tango::UserDefaultAttrProp	alithreshold_prop;
	//	description	not set for AlIThreshold
	//	label	not set for AlIThreshold
	//	unit	not set for AlIThreshold
	//	standard_unit	not set for AlIThreshold
	//	display_unit	not set for AlIThreshold
	//	format	not set for AlIThreshold
	//	max_value	not set for AlIThreshold
	//	min_value	not set for AlIThreshold
	//	max_alarm	not set for AlIThreshold
	//	min_alarm	not set for AlIThreshold
	//	max_warning	not set for AlIThreshold
	//	min_warning	not set for AlIThreshold
	//	delta_t	not set for AlIThreshold
	//	delta_val	not set for AlIThreshold
	
	alithreshold->set_default_properties(alithreshold_prop);
	//	Not Polled
	alithreshold->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(alithreshold);

	//	Attribute : AlLibera3hc
	AlLibera3hcAttrib	*allibera3hc = new AlLibera3hcAttrib();
	Tango::UserDefaultAttrProp	allibera3hc_prop;
	//	description	not set for AlLibera3hc
	//	label	not set for AlLibera3hc
	//	unit	not set for AlLibera3hc
	//	standard_unit	not set for AlLibera3hc
	//	display_unit	not set for AlLibera3hc
	//	format	not set for AlLibera3hc
	//	max_value	not set for AlLibera3hc
	//	min_value	not set for AlLibera3hc
	//	max_alarm	not set for AlLibera3hc
	//	min_alarm	not set for AlLibera3hc
	//	max_warning	not set for AlLibera3hc
	//	min_warning	not set for AlLibera3hc
	//	delta_t	not set for AlLibera3hc
	//	delta_val	not set for AlLibera3hc
	
	allibera3hc->set_default_properties(allibera3hc_prop);
	//	Not Polled
	allibera3hc->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(allibera3hc);

	//	Attribute : Seq_state
	Seq_stateAttrib	*seq_state = new Seq_stateAttrib();
	Tango::UserDefaultAttrProp	seq_state_prop;
	//	description	not set for Seq_state
	//	label	not set for Seq_state
	//	unit	not set for Seq_state
	//	standard_unit	not set for Seq_state
	//	display_unit	not set for Seq_state
	//	format	not set for Seq_state
	//	max_value	not set for Seq_state
	//	min_value	not set for Seq_state
	//	max_alarm	not set for Seq_state
	//	min_alarm	not set for Seq_state
	//	max_warning	not set for Seq_state
	//	min_warning	not set for Seq_state
	//	delta_t	not set for Seq_state
	//	delta_val	not set for Seq_state
	
	seq_state->set_default_properties(seq_state_prop);
	//	Not Polled
	seq_state->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(seq_state);

	//	Attribute : EnableBPM11_2
	EnableBPM11_2Attrib	*enablebpm11_2 = new EnableBPM11_2Attrib();
	Tango::UserDefaultAttrProp	enablebpm11_2_prop;
	//	description	not set for EnableBPM11_2
	//	label	not set for EnableBPM11_2
	//	unit	not set for EnableBPM11_2
	//	standard_unit	not set for EnableBPM11_2
	//	display_unit	not set for EnableBPM11_2
	//	format	not set for EnableBPM11_2
	//	max_value	not set for EnableBPM11_2
	//	min_value	not set for EnableBPM11_2
	//	max_alarm	not set for EnableBPM11_2
	//	min_alarm	not set for EnableBPM11_2
	//	max_warning	not set for EnableBPM11_2
	//	min_warning	not set for EnableBPM11_2
	//	delta_t	not set for EnableBPM11_2
	//	delta_val	not set for EnableBPM11_2
	
	enablebpm11_2->set_default_properties(enablebpm11_2_prop);
	//	Not Polled
	enablebpm11_2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(enablebpm11_2);

	//	Attribute : OpenId
	OpenIdAttrib	*openid = new OpenIdAttrib();
	Tango::UserDefaultAttrProp	openid_prop;
	//	description	not set for OpenId
	//	label	not set for OpenId
	//	unit	not set for OpenId
	//	standard_unit	not set for OpenId
	//	display_unit	not set for OpenId
	//	format	not set for OpenId
	//	max_value	not set for OpenId
	//	min_value	not set for OpenId
	//	max_alarm	not set for OpenId
	//	min_alarm	not set for OpenId
	//	max_warning	not set for OpenId
	//	min_warning	not set for OpenId
	//	delta_t	not set for OpenId
	//	delta_val	not set for OpenId
	
	openid->set_default_properties(openid_prop);
	//	Not Polled
	openid->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(openid);

	//	Attribute : DiodeDet
	DiodeDetAttrib	*diodedet = new DiodeDetAttrib();
	Tango::UserDefaultAttrProp	diodedet_prop;
	//	description	not set for DiodeDet
	//	label	not set for DiodeDet
	//	unit	not set for DiodeDet
	//	standard_unit	not set for DiodeDet
	//	display_unit	not set for DiodeDet
	//	format	not set for DiodeDet
	//	max_value	not set for DiodeDet
	//	min_value	not set for DiodeDet
	//	max_alarm	not set for DiodeDet
	//	min_alarm	not set for DiodeDet
	//	max_warning	not set for DiodeDet
	//	min_warning	not set for DiodeDet
	//	delta_t	not set for DiodeDet
	//	delta_val	not set for DiodeDet
	
	diodedet->set_default_properties(diodedet_prop);
	//	Not Polled
	diodedet->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(diodedet);

	//	Attribute : LiberaSt
	LiberaStAttrib	*liberast = new LiberaStAttrib();
	Tango::UserDefaultAttrProp	liberast_prop;
	//	description	not set for LiberaSt
	//	label	not set for LiberaSt
	//	unit	not set for LiberaSt
	//	standard_unit	not set for LiberaSt
	//	display_unit	not set for LiberaSt
	//	format	not set for LiberaSt
	//	max_value	not set for LiberaSt
	//	min_value	not set for LiberaSt
	//	max_alarm	not set for LiberaSt
	//	min_alarm	not set for LiberaSt
	//	max_warning	not set for LiberaSt
	//	min_warning	not set for LiberaSt
	//	delta_t	not set for LiberaSt
	//	delta_val	not set for LiberaSt
	
	liberast->set_default_properties(liberast_prop);
	//	Not Polled
	liberast->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(liberast);

	//	Attribute : LiberaNd
	LiberaNdAttrib	*liberand = new LiberaNdAttrib();
	Tango::UserDefaultAttrProp	liberand_prop;
	//	description	not set for LiberaNd
	//	label	not set for LiberaNd
	//	unit	not set for LiberaNd
	//	standard_unit	not set for LiberaNd
	//	display_unit	not set for LiberaNd
	//	format	not set for LiberaNd
	//	max_value	not set for LiberaNd
	//	min_value	not set for LiberaNd
	//	max_alarm	not set for LiberaNd
	//	min_alarm	not set for LiberaNd
	//	max_warning	not set for LiberaNd
	//	min_warning	not set for LiberaNd
	//	delta_t	not set for LiberaNd
	//	delta_val	not set for LiberaNd
	
	liberand->set_default_properties(liberand_prop);
	//	Not Polled
	liberand->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(liberand);

	//	Attribute : IlkEnable
	IlkEnableAttrib	*ilkenable = new IlkEnableAttrib();
	Tango::UserDefaultAttrProp	ilkenable_prop;
	//	description	not set for IlkEnable
	//	label	not set for IlkEnable
	//	unit	not set for IlkEnable
	//	standard_unit	not set for IlkEnable
	//	display_unit	not set for IlkEnable
	//	format	not set for IlkEnable
	//	max_value	not set for IlkEnable
	//	min_value	not set for IlkEnable
	//	max_alarm	not set for IlkEnable
	//	min_alarm	not set for IlkEnable
	//	max_warning	not set for IlkEnable
	//	min_warning	not set for IlkEnable
	//	delta_t	not set for IlkEnable
	//	delta_val	not set for IlkEnable
	
	ilkenable->set_default_properties(ilkenable_prop);
	//	Not Polled
	ilkenable->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(ilkenable);

	//	Attribute : AlOpenId
	AlOpenIdAttrib	*alopenid = new AlOpenIdAttrib();
	Tango::UserDefaultAttrProp	alopenid_prop;
	//	description	not set for AlOpenId
	//	label	not set for AlOpenId
	//	unit	not set for AlOpenId
	//	standard_unit	not set for AlOpenId
	//	display_unit	not set for AlOpenId
	//	format	not set for AlOpenId
	//	max_value	not set for AlOpenId
	//	min_value	not set for AlOpenId
	//	max_alarm	not set for AlOpenId
	//	min_alarm	not set for AlOpenId
	//	max_warning	not set for AlOpenId
	//	min_warning	not set for AlOpenId
	//	delta_t	not set for AlOpenId
	//	delta_val	not set for AlOpenId
	
	alopenid->set_default_properties(alopenid_prop);
	//	Not Polled
	alopenid->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(alopenid);

	//	Attribute : AlDiodeDet
	AlDiodeDetAttrib	*aldiodedet = new AlDiodeDetAttrib();
	Tango::UserDefaultAttrProp	aldiodedet_prop;
	//	description	not set for AlDiodeDet
	//	label	not set for AlDiodeDet
	//	unit	not set for AlDiodeDet
	//	standard_unit	not set for AlDiodeDet
	//	display_unit	not set for AlDiodeDet
	//	format	not set for AlDiodeDet
	//	max_value	not set for AlDiodeDet
	//	min_value	not set for AlDiodeDet
	//	max_alarm	not set for AlDiodeDet
	//	min_alarm	not set for AlDiodeDet
	//	max_warning	not set for AlDiodeDet
	//	min_warning	not set for AlDiodeDet
	//	delta_t	not set for AlDiodeDet
	//	delta_val	not set for AlDiodeDet
	
	aldiodedet->set_default_properties(aldiodedet_prop);
	//	Not Polled
	aldiodedet->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(aldiodedet);

	//	Attribute : AlLiberaSt
	AlLiberaStAttrib	*alliberast = new AlLiberaStAttrib();
	Tango::UserDefaultAttrProp	alliberast_prop;
	//	description	not set for AlLiberaSt
	//	label	not set for AlLiberaSt
	//	unit	not set for AlLiberaSt
	//	standard_unit	not set for AlLiberaSt
	//	display_unit	not set for AlLiberaSt
	//	format	not set for AlLiberaSt
	//	max_value	not set for AlLiberaSt
	//	min_value	not set for AlLiberaSt
	//	max_alarm	not set for AlLiberaSt
	//	min_alarm	not set for AlLiberaSt
	//	max_warning	not set for AlLiberaSt
	//	min_warning	not set for AlLiberaSt
	//	delta_t	not set for AlLiberaSt
	//	delta_val	not set for AlLiberaSt
	
	alliberast->set_default_properties(alliberast_prop);
	//	Not Polled
	alliberast->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(alliberast);

	//	Attribute : AlLiberaNd
	AlLiberaNdAttrib	*alliberand = new AlLiberaNdAttrib();
	Tango::UserDefaultAttrProp	alliberand_prop;
	//	description	not set for AlLiberaNd
	//	label	not set for AlLiberaNd
	//	unit	not set for AlLiberaNd
	//	standard_unit	not set for AlLiberaNd
	//	display_unit	not set for AlLiberaNd
	//	format	not set for AlLiberaNd
	//	max_value	not set for AlLiberaNd
	//	min_value	not set for AlLiberaNd
	//	max_alarm	not set for AlLiberaNd
	//	min_alarm	not set for AlLiberaNd
	//	max_warning	not set for AlLiberaNd
	//	min_warning	not set for AlLiberaNd
	//	delta_t	not set for AlLiberaNd
	//	delta_val	not set for AlLiberaNd
	
	alliberand->set_default_properties(alliberand_prop);
	//	Not Polled
	alliberand->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(alliberand);

	//	Attribute : Seq_num
	Seq_numAttrib	*seq_num = new Seq_numAttrib();
	Tango::UserDefaultAttrProp	seq_num_prop;
	//	description	not set for Seq_num
	//	label	not set for Seq_num
	//	unit	not set for Seq_num
	//	standard_unit	not set for Seq_num
	//	display_unit	not set for Seq_num
	//	format	not set for Seq_num
	//	max_value	not set for Seq_num
	//	min_value	not set for Seq_num
	//	max_alarm	not set for Seq_num
	//	min_alarm	not set for Seq_num
	//	max_warning	not set for Seq_num
	//	min_warning	not set for Seq_num
	//	delta_t	not set for Seq_num
	//	delta_val	not set for Seq_num
	
	seq_num->set_default_properties(seq_num_prop);
	//	Not Polled
	seq_num->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(seq_num);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(PLCsocketClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void PLCsocketClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(PLCsocketClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::pipe_factory_before
	/*----- PROTECTED REGION ID(PLCsocketClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void PLCsocketClass::command_factory()
{
	/*----- PROTECTED REGION ID(PLCsocketClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::command_factory_before


	//	Command Beam_dump
	Beam_dumpClass	*pBeam_dumpCmd =
		new Beam_dumpClass("Beam_dump",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pBeam_dumpCmd);

	//	Command Send_ack
	Send_ackClass	*pSend_ackCmd =
		new Send_ackClass("Send_ack",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSend_ackCmd);

	//	Command Seq_state_rst
	Seq_state_rstClass	*pSeq_state_rstCmd =
		new Seq_state_rstClass("Seq_state_rst",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSeq_state_rstCmd);

	//	Command Test_debug
	Test_debugClass	*pTest_debugCmd =
		new Test_debugClass("Test_debug",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pTest_debugCmd);

	//	Command EnableBPM11_2
	EnableBPM11_2Class	*pEnableBPM11_2Cmd =
		new EnableBPM11_2Class("EnableBPM11_2",
			Tango::DEV_BOOLEAN, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pEnableBPM11_2Cmd);

	//	Command DisableInterlockSCW
	DisableInterlockSCWClass	*pDisableInterlockSCWCmd =
		new DisableInterlockSCWClass("DisableInterlockSCW",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDisableInterlockSCWCmd);

	//	Command DisableInterlockID5
	DisableInterlockID5Class	*pDisableInterlockID5Cmd =
		new DisableInterlockID5Class("DisableInterlockID5",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDisableInterlockID5Cmd);

	/*----- PROTECTED REGION ID(PLCsocketClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		PLCsocketClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void PLCsocketClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(PLCsocketClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		PLCsocketClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void PLCsocketClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		PLCsocket *dev = static_cast<PLCsocket *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(PLCsocketClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocketClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *PLCsocketClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(PLCsocketClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::Additional Methods
} //	namespace
