/*
 * plcsrvthread.cpp
 *
 *	10.04.06 - SF: first release  
 *
 *
 */

#include "plcsrvthread.h"
#include <iomanip>      //used for debug dump of db

/* 
 *	plcsrvthread::run()
 *	Run  
 */		
void *plcsrvthread::run_undetached(void *) 
{
	
	int pausemicro = 3000000;
	server_started=0;
	first_read=0;
	
	
	while (!t_PLCsocket->abortflag) { 
	
		if(server_started==0)
			Srv_Prepare(); 
		else
   			t_PLCsocket->set_state(Tango::FAULT);
			t_PLCsocket->set_status("srv not connected");
		
		usleep(pausemicro);	
		DEBUG_STREAM << "plcsrvthread::run() trying to reconnect" << endl;
	}
	
}




void plcsrvthread::Srv_Prepare(void)
{
	//creating server socket
   	if (( t_PLCsocket->sock = socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {
		server_started=0;
   		t_PLCsocket->set_state(Tango::FAULT);
		t_PLCsocket->set_status("srv sock creating failure");
		DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock creating failure" << endl;
		return;
	}
   	myname.sin_family = AF_INET;  
   	myname.sin_port = htons(t_PLCsocket->rport);  /// rport=server port
	myname.sin_addr.s_addr = inet_addr(t_PLCsocket->srv_host.c_str()); 
	 
   	if (bind(t_PLCsocket->sock, (const sockaddr*)&myname, sizeof(myname) ) < 0 ) {
         	close (t_PLCsocket->sock); 
		server_started=0;
   		t_PLCsocket->set_state(Tango::FAULT);
		t_PLCsocket->set_status("srv sock bind failure");
		DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock bind failure" << endl;
		return;
   	}
	
	//server socket listening
	
   	if ( listen ( t_PLCsocket->sock, MAX_NUM_SOCK ) < 0 ) { 
         	close (t_PLCsocket->sock); 
		server_started=0;
   		t_PLCsocket->set_state(Tango::FAULT);
		t_PLCsocket->set_status("srv sock listen failure");
		DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock listen failure" << endl;
		return;
   	}
	
	while (!t_PLCsocket->abortflag) { 
		int adrlen = sizeof(struct sockaddr);	
		server_started=1; //the server is listening
		
	//semaphore management
   		retval = 0;
   		id = semget(1000, 1, 0666);
   		if(id < 0){
			DEBUG_STREAM << "plcsrvthread::srvThread cannot find semaphore" << endl;
   		}
   		else{
			DEBUG_STREAM << "plcsrvthread::srvThread found semaphore" << endl;
   		}
	//assign the accepted socket to new_sd
	
      		if ( ( t_PLCsocket->new_sd = accept ( t_PLCsocket->sock, (sockaddr*)&addr, (socklen_t*)&adrlen ) ) < 0 ) {
   			t_PLCsocket->set_state(Tango::FAULT);
			t_PLCsocket->set_status("srv sock accept failure");
			DEBUG_STREAM << "plcsrvthread::Srv_Prepare() srv sock accept failure" << endl;
      		}
		else{//connection established
			t_PLCsocket->set_state(Tango::ON);
			t_PLCsocket->set_status("accepted connection");
			DEBUG_STREAM << "plcsrvthread::Srv_Prepare() accepted connection" << endl;
	
			nptr = (struct sockaddr_in *) &addr;  
  			int counter = 0;//number of read counter
			errcount =0;
			
        		do {
             		memset (buf,0,SRV_BUF_LEN);

         // read message from remote client
	    		int islost = 0;
			DEBUG_STREAM << "plcsrvthread::Srv_Prepare() sizes:" << SRV_BUF_LEN <<" "<< (sizeof(PLCsocket_ns::intlck_libera))<<endl;

            		if (( cnt = read (t_PLCsocket->new_sd, buf, (sizeof(PLCsocket_ns::intlck_libera)))) < 0 ) {
				t_PLCsocket->set_state(Tango::FAULT);
				t_PLCsocket->set_status("read failed");
				DEBUG_STREAM << "plcsrvthread::Srv_Prepare() read failed" << endl;
				break; 
            		}
            		else
            		if (cnt == 0) {
               			continue; 
            		}
            		else { //reading ok
				//if message.is_valid()
						gettimeofday(&_pre,NULL);
	
				if(cnt == (sizeof(PLCsocket_ns::intlck_libera))){//the message has the right size
				
					INFO_STREAM << "plcsrvthread::Srv_Prepare() message read" << endl;
					DEBUG_STREAM << "plcsrvthread::Srv_Prepare() message cnt:" << cnt<<endl;
					for(int k=0;k<cnt;)
					{
						stringstream tmp;
						int g;
						tmp << "db50: "<<setw(3)<<setfill(' ')<<k<<" -> ";
						for(g=0; g<10; g++)
						{
							if(k+g>=cnt)
								break;
							tmp << " " <<hex<<setw(2)<<setfill(' ')<< (int)(unsigned char)buf[k+g];
						}
						k+=g;
						if(k<cnt)
						{
							tmp << " |  "<<dec<<setw(3)<<setfill(' ')<<k<<hex<<" -> ";
							for(g=0; g<10; g++)
							{
								if(k+g>=cnt)
									break;
								tmp << " " <<hex<<setw(2)<<setfill(' ')<< (int)(unsigned char)buf[k+g];
							}
							k+=g;
						}
						DEBUG_STREAM<<tmp.str()<<dec<<endl;
					}
					unsigned short int sbuf[SRV_BUF_LEN];//TODO: stinks... show be made dynamic
					unsigned long s1, s2, s3;
             				memset (sbuf,0,(sizeof(PLCsocket_ns::intlck_libera)));
		  			bcopy(&buf, &sbuf, (sizeof(PLCsocket_ns::intlck_libera)));
					for (int i=0; i<cnt; i++){
						sbuf[i] = ntohs(sbuf[i]);
					}
					
					for (int i=0; i<7; i++){
						sbuf[i] = plc_swap(sbuf[i]);
					}
					
					
		  			bcopy(&sbuf, &buf, (sizeof(PLCsocket_ns::intlck_libera)));
					
				//now saving the old timestamp before overwriting
					for(int j=0;j<TSTAMP_SIZE;j++){
						t_PLCsocket->old_timestamp[j] = local_mesg.tstamp_campo[j];
					}
					
					
				//saving message
		  			bcopy(&buf, &local_mesg, (sizeof(PLCsocket_ns::intlck_libera)));
					s1 = local_mesg.seq_num;
					s2 = local_mesg.seq_async;
					s3 = local_mesg.seq_sent;
					local_mesg.seq_num = plc_swaplong(s1);
					local_mesg.seq_async = plc_swaplong(s2);
					local_mesg.seq_sent = plc_swaplong(s3);
				
				//now saving the new timestamp 
					for(int j=0;j<TSTAMP_SIZE;j++){
						t_PLCsocket->new_timestamp[j] = local_mesg.tstamp_campo[j];
					}
				//sequence number control
					if(first_read !=0){	//is not the first message, seq_num control
						if((local_mesg.seq_num)!=(first_read+1)){
							t_PLCsocket->seq[0] = local_mesg.seq_num;	
							t_PLCsocket->s_state = LOSTPK_ST;
							islost = 1;

							DEBUG_STREAM << "plcsrvthread::Srv_Prepare() change message lost: " << local_mesg.seq_num \
							<< " instead of " << first_read+1 << endl;
						}
						else islost = 0;
					}
					first_read = local_mesg.seq_num;
					
				//lock mesg_list with semaphore
    					operations[0].sem_num = 0;
    					operations[0].sem_op = 1;
    					operations[0].sem_flg = 0;

    					retval = semop(id, operations, 1);//semaphore incremented

				//saving message to fifo list
					t_PLCsocket->mesg_list.push_back(local_mesg);

				//unlock mesg_list with semaphore
    					operations[0].sem_num = 0;
    					operations[0].sem_op = -1;
    					operations[0].sem_flg = 0;

    					retval = semop(id, operations, 1);//semaphore decremented

					if(islost==1){
						gettimeofday(&_post,NULL);
						int tempo = (_post.tv_sec - _pre.tv_sec)*1000000 +
							(int)((float)(_post.tv_usec -  _pre.tv_usec)) ;
	//					DEBUG_STREAM << "plcsrvthread::Srv_Prepare() read cycle time: "<< tempo << endl;
					}
 				}  //end of if count == mesg_len
				else{
					if(t_PLCsocket->get_state()!=Tango::FAULT)
						t_PLCsocket->set_state(Tango::UNKNOWN);
					t_PLCsocket->set_status("wrong message length");
					DEBUG_STREAM << "plcsrvthread::Srv_Prepare() wrong message length: "<< cnt << endl;
				}
            		}  // end of message-print else 

         		  // end of do loop statement 
         		}while ((cnt > 0)&&(!t_PLCsocket->abortflag));  // do loop condition 
			}//end of accept else
  	}  // end of while (1) 
	server_started=0;
	return;
	
}

uint16_t plcsrvthread::plc_swap(uint16_t in)
{
	return ((in>>8)|((in&0x00ff)<<8));
}

uint32_t plcsrvthread::plc_swaplong(uint32_t in)
{
	return ((in>>16)|((in&0x0000ffff)<<16));
}




