/*
 * plctimingthread.cpp
 *
 *	10.04.06 - SF: first release  
 *
 *
 */

#include "plctimingthread.h"

//default hour and minute for timeadjust
#define TIMEADJUST_DEF_H 3
#define TIMEADJUST_DEF_M 5

/* 
 *	plctimingthread::run()
 *	Run  
 */		
void *plctimingthread::run_undetached(void *) 
{
	struct timeval _pre2, _post2;
	int pausesec2,pausenano2;
	unsigned char buf_local_tstamp[TSTAMP_SIZE];
	char buf_tmp[10];
	
	int ch_hour, ch_min;
	ch_hour = TIMEADJUST_DEF_H;
	ch_min = TIMEADJUST_DEF_M;
	char s_hour, s_min, ch_today;
	ch_today = 0;
	int pos = (t_PLCsocket->timeadjust).find(":");
	if(pos>0){
		ch_hour = atoi(((t_PLCsocket->timeadjust).substr(0, pos)).c_str());
		ch_min = atoi(((t_PLCsocket->timeadjust).substr(pos+1, (t_PLCsocket->timeadjust).length()).c_str()));
		if((ch_hour<0)||(ch_hour>23)||(ch_min<0)||(ch_min>59)){
			DEBUG_STREAM << "plctimingthread::run() timeadjust not valid, using "<<TIMEADJUST_DEF_H<<":"<<TIMEADJUST_DEF_M << endl;
			ch_hour = TIMEADJUST_DEF_H;
			ch_min = TIMEADJUST_DEF_M;
		}
	}
	else{
		DEBUG_STREAM << "plctimingthread::run() timeadjust not valid, using "<<TIMEADJUST_DEF_H<<":"<<TIMEADJUST_DEF_M << endl;
	}
        memset (buf_tmp,0,10);
	sprintf(buf_tmp, "%02d", ch_hour);
	s_hour = (buf_tmp[0]-'0'<<4)+buf_tmp[1]-'0';
        memset (buf_tmp,0,10);
	sprintf(buf_tmp, "%02d", ch_min);
	s_min = (buf_tmp[0]-'0'<<4)+buf_tmp[1]-'0';
        memset (buf_local_tstamp,0,TSTAMP_SIZE);
	pausesec2 = (int)((t_PLCsocket->hbeat)/1000);
	pausenano2 = ((t_PLCsocket->hbeat)%1000)*1000000;
	usleep(pausesec2*1000000+pausenano2/1000);//sleep for heartbeat time, for setup
	
	
	//semaphore management
	
	retval = 0;
	while (!t_PLCsocket->abortflag) { 
		
	//log to db elements of the message list
		int k=0;

		PLCsocket_ns::intlck_libera_t m;
		for(int k=TSTAMP_SIZE-1;k>=0;k--){
			buf_local_tstamp[k]=t_PLCsocket->new_timestamp[k];
		}
		
		usleep(pausesec2*1000000+pausenano2/1000);//sleep for heartbeat time
		INFO_STREAM << "plctimingthread::run() hbeat ctrl" << endl;
		
	//verify timestamp
			
		int equals = 1;
		int no_read = 1;
		for(int k=TSTAMP_SIZE-1;k>=0;k--){
			if(t_PLCsocket->old_timestamp[k]!=t_PLCsocket->new_timestamp[k])
				equals = 0;
			}
		for(int k=TSTAMP_SIZE-1;k>=0;k--){
			if(buf_local_tstamp[k]!=t_PLCsocket->new_timestamp[k])
				no_read = 0;
			}

			
	// calculates timestamp for the time of the server clock
		string tst = calc_timest();
		PLCsocket_ns::tstamp_t now;
			
		for(int k=TSTAMP_SIZE-1;k>=0;k--){
			now[k] = tst.c_str()[k];
		}
		
		//condition for plc time adjust
		if(((now[5]-s_min)==0)&&((now[2]-s_hour)==0)&&((now[3]-ch_today)!=0)){
			t_PLCsocket->sync_plc(now);
			ch_today = now[3];//time adjust once a day
		}
		for(int k=TSTAMP_SIZE-1;k>=0;k--){
			t_PLCsocket->last_ck_read[k] = now[k];
		}
		
	// translates bcd timestamp into a readable string
			
		if(equals == 1){
			t_PLCsocket->set_state(Tango::FAULT);
			t_PLCsocket->set_status("timestamp is not changing");
			DEBUG_STREAM << "plctimingthread::run() timestamp is not changing" << endl;
		}
		else if(no_read == 1){
			t_PLCsocket->set_state(Tango::FAULT);
			t_PLCsocket->set_status("no new data available");
			DEBUG_STREAM << "plctimingthread::run() no new data available" << endl;
		}
		else{
			int c =  calc_diff_tst(t_PLCsocket->old_timestamp, t_PLCsocket->new_timestamp);
			if(c < 0){
				t_PLCsocket->set_state(Tango::FAULT);
				t_PLCsocket->set_status("negative difference between timestamps");
				DEBUG_STREAM << "plctimingthread::run() negative difference between timestamps" << endl;
			}
			else{
				if(c > pausesec2*1000+pausenano2/1000000){
					t_PLCsocket->set_state(Tango::FAULT);
					t_PLCsocket->set_status("data too old");
					DEBUG_STREAM << "plctimingthread::run() data too old" << endl;
				}
				else{
					t_PLCsocket->set_state(Tango::ON);
					t_PLCsocket->set_status("timestamp ok");
					DEBUG_STREAM << "plctimingthread::run() timestamp ok" << endl;
				}
			}
		}
	}
}






/*
 *  generates a  bcd timestamp for the current time
 */
string plctimingthread::calc_timest()
{

	timeval seco;
	string tstamp;
	string out;
	int rest;
	char c;
	char buf[10];
        memset (buf,0,sizeof(buf));
	gettimeofday(&seco,NULL);
             time_t tim=time(NULL);
             tm *now=localtime(&tim);
	out.resize(TSTAMP_SIZE);
	sprintf(buf, "%02d", (now->tm_year-100));//change here the format of saved data
	tstamp.append(buf);
	out[1] = (buf[0]-'0'<<4)+buf[1]-'0';
	
        memset (buf,0,sizeof(buf));
	sprintf(buf, "%02d", (now->tm_mon+1));//change here the format of saved data
	tstamp.append(buf);
	out[0] = (buf[0]-'0'<<4)+buf[1]-'0';
	
        memset (buf,0,sizeof(buf));
	sprintf(buf, "%02d", (now->tm_mday));//change here the format of saved data
	tstamp.append(buf);
	out[3] = (buf[0]-'0'<<4)+buf[1]-'0';
	
        memset (buf,0,sizeof(buf));
	sprintf(buf, "%02d", (now->tm_hour));//change here the format of saved data
	tstamp.append(buf);
	out[2] = (buf[0]-'0'<<4)+buf[1]-'0';
	
        memset (buf,0,sizeof(buf));
	sprintf(buf, "%02d", (now->tm_min));//change here the format of saved data
	tstamp.append(buf);
	out[5] = (buf[0]-'0'<<4)+buf[1]-'0';
	
        memset (buf,0,sizeof(buf));
	sprintf(buf, "%02d", (now->tm_sec));//change here the format of saved data
	tstamp.append(buf);
	out[4] = (buf[0]-'0'<<4)+buf[1]-'0';
	
        memset (buf,0,sizeof(buf));
	sprintf(buf, "%03d", ((int)(seco.tv_usec/1000)));//change here the format of saved data
	tstamp.append(buf);
	out[7] = ((buf[0]-'0'<<4)+buf[1]-'0')&0x00ffff;
	rest = buf[2]-'0';
	
        memset (buf,0,sizeof(buf));
	sprintf(buf, "%01d", (now->tm_wday+1));//change here the format of saved data
	tstamp.append(buf);
	out[6] = ((rest<<4)+buf[0]-'0')&0x00ffff;
	
        memset (buf,0,sizeof(buf));
	tstamp.append("\n");
	out.resize(TSTAMP_SIZE);
	
return out;
	
}	/* end calc_timest() */



/* 
 *	plctimingthread::calc_diff_tst()
 *	 calculates difference between packet time and now(in seconds) 
 *	controllare t_old e t_new
 */		
int plctimingthread::calc_diff_tst(PLCsocket_ns::tstamp_t t_old, PLCsocket_ns::tstamp_t t_new)
{
	char buffer [10];
	int d = 0;
	tm t1, t2;
        time_t to;
        time_t tn;
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_old[4]);
	t1.tm_sec = atoi(buffer);
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_old[5]);
	t1.tm_min = atoi(buffer);// the hour isn't exact, cut the -1
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_old[2]);
	t1.tm_hour = atoi(buffer);// the hour isn't exact, cut the -1
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_old[3]);
	t1.tm_mday = atoi(buffer);
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_old[0]);
	t1.tm_mon = atoi(buffer)-1;
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_old[1]);
	t1.tm_year = atoi(buffer)+100;
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_old[6]);
	t1.tm_wday = atoi(buffer)-1;

	to = mktime(&t1);
	
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_new[4]);
	t2.tm_sec = atoi(buffer);
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_new[5]);
	t2.tm_min = atoi(buffer);
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_new[2]);
	t2.tm_hour = atoi(buffer);
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_new[3]);
	t2.tm_mday = atoi(buffer);
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_new[0]);
	t2.tm_mon = atoi(buffer)-1;
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_new[1]);
	t2.tm_year = atoi(buffer)+100;
        memset (buffer,0,sizeof(buffer));
	sprintf (buffer, "%x", t_new[6]);
	t2.tm_wday = atoi(buffer)-1;

	tn = mktime(&t2);
	
	d = (tn-to)*1000;
		int ms_old, ms_new, c1, c2;
		ms_old = ms_new = 0;
        	memset (buffer,0,sizeof(buffer));
		sprintf (buffer, "%x", t_old[7]);
		c1 = atoi(buffer);
        	memset (buffer,0,sizeof(buffer));
		sprintf (buffer, "%x", t_old[6]);
		c2 = atoi(buffer);
		ms_old = c1*10+((c2)>>4);
        	memset (buffer,0,sizeof(buffer));
		sprintf (buffer, "%x", t_new[7]);
		c1 = atoi(buffer);
        	memset (buffer,0,sizeof(buffer));
		sprintf (buffer, "%x", t_new[6]);
		c2 = atoi(buffer);
		ms_new = c1*10+(c2>>4);
		d += (ms_new-ms_old);
	
	return d;

}	/* end calc_diff_tst() */


