/*
 * plctimingthread.h
 *
 *	17.01.07 - SF: heartbeat
 */ 

#ifndef plctimingthread_H
#define plctimingthread_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <signal.h>
#include <netdb.h>    
#include "PLCsocket.h"

class plctimingthread : public omni_thread, public Tango::LogAdapter
{	
	private:
		PLCsocket_ns::PLCsocket::PLCsocket *t_PLCsocket;		
				
	public:
		
		plctimingthread(PLCsocket_ns::PLCsocket::PLCsocket *s):Tango::LogAdapter(s){ t_PLCsocket = s;};
		
		~plctimingthread() {};
		
		void *StartUndetached(){
			start_undetached();
		}
		void *run_undetached(void *);	
					
	protected:
	
   		struct sembuf operations[1];
   		struct sembuf lock_ops[1];
   		struct sembuf unlock_ops[1];
   		int retval;
   		int id;
		
		struct timeval _pre2, _post2;
		string calc_timest();
		int calc_diff_tst(PLCsocket_ns::tstamp_t, PLCsocket_ns::tstamp_t);
				
};	/* end class plctimingthread() */



#endif

/* EOF */
